---
title: RTCDataChannelEvent
slug: Web/API/RTCDataChannelEvent
tags:
  - API
  - Experimental
  - Interface
  - RTCDataChannelEvent
  - Reference
  - WebRTC
  - datachannel
---
<p>{{APIRef("WebRTC")}}{{SeeCompatTable}}</p>

<p>The <strong><code>RTCDataChannelEvent()</code></strong> constructor returns a new {{domxref("RTCDataChannelEvent")}} object, which represents a {{domxref("datachannel")}} event. These events sent to an {{domxref("RTCPeerConnection")}} when its remote peer is asking to open an {{domxref("RTCDataChannel")}} between the two peers.</p>

<p>You will rarely if ever construct an <code>RTCDataChannelEvent</code> by hand; instead, the WebRTC layer will generate and deliver them to you at the appropriate time. Just listen for the {{domxref("RTCPeerConnection.datachannel_event", "datachannel")}} event to be received by the <code>RTCPeerConnection</code> and when you receive it, use the {{domxref("RTCDataChannelEvent.channel")}} property to gain access to the data channel which has been opened.</p>

<div>{{InterfaceOverview("WebRTC")}}</div>

<h2 id="Examples">Examples</h2>

<p>In this example, the <code>datachannel</code> event handler is set up to save the data channel reference and set up handlers for the events which need to be monitored. The {{domxref("RTCDataChannelEvent.channel", "channel")}} property provides the {{domxref("RTCDataChannel")}} representing the connection to the other peer.</p>

<pre class="brush: js">pc.ondatachannel = function(event) {
  inboundDataChannel = event.channel;
  inboundDataChannel.onmessage = handleIncomingMessage;
  inboundDataChannel.onopen = handleChannelOpen;
  inboundDataChannel.onclose = handleChannelClose;
}
</pre>

<p>See <a href="/en-US/docs/Web/API/WebRTC_API/Simple_RTCDataChannel_sample">A simple RTCDataChannel sample</a> for another, more complete, example of how to use data channels.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#rtcdatachannelevent', 'RTCDataChannelEvent') }}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCDataChannelEvent")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Guide/API/WebRTC" title="/en-US/docs/CSS/Using_CSS_animations">WebRTC</a></li>
 <li>{{domxref("RTCDataChannel")}}</li>
 <li>{{domxref("RTCDataChannel.ondatachannel")}}</li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Simple_RTCDataChannel_sample">A simple RTCDataChannel sample</a></li>
 <li>{{domxref("RTCPeerConnection")}} (the target interface for {{event("datachannel")}} events)</li>
</ul>
